////////////////////////////////////////////////////////////////////////
// error.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.error")

// <%pre>
#line 1 "error.ecpp"


#include <setup.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class error_widget_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        error_widget_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    error_widget_type error_widget;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("error");

static const char* rawData = "0\000\000\0001\000\000\000\236\000\000\000\251\000\000\000\357\000\000\000\362\000\000"
  "\000\015\001\000\000(\001\000\000)\001\000\000x\001\000\000\235\001\000\000\262\001\000\000\n\n<html>\n\t<head>\n\t\t"
  "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t<"
  "/head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t"
  "\t\n\t\t</div>\n\t</body>\n</html>\n\t\t<table class=\"error\" cellpadding=\"0\" cellspacing=\"0\">\n\t\t<tr><td clas"
  "s=\"title\"></td></tr>\n\t\t<tr><td class=\"message\"></td></tr>\n\t</table>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    error_widget(*this, "error_widget")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("error " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string pageTitle = qparam.get< std::string >("pageTitle");
std::string errorTitle = qparam.get< std::string >("errorTitle", ( tr("Page error")));
std::string errorMessage = qparam.get< std::string >("errorMessage");
  // </%args>

#line 14 "error.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 16 "error.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << _tntChunks[0]; // \n
  // <& pageelems.doc_type ...
  { 
#line 19 "error.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 19 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 23 "error.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 24 "error.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 24 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 27 "error.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 27 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t
  // <& menu ...
  { 
#line 28 "error.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 28 "error.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t<div class="inhalt">\n\t\t\t
  // <& error.error_widget ...
  { 
#line 30 "error.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 30 "error.ecpp"
    _tnt_cq4.add( "errorMessage", (errorMessage));
#line 30 "error.ecpp"
    _tnt_cq4.add( "errorTitle", (errorTitle));
#line 30 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "error", "error_widget"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t\t</div>\n\t</body>\n</html>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::error_widget_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("error::error_widget " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string errorTitle = qparam.get< std::string >("errorTitle");
std::string errorMessage = qparam.get< std::string >("errorMessage");
  // </%args>

#line 14 "error.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
  reply.out() << _tntChunks[7]; // \t
  reply.out() << _tntChunks[8]; // \t<table class="error" cellpadding="0" cellspacing="0">\n\t\t<tr><td class="title">
#line 40 "error.ecpp"
  reply.sout() << ( errorTitle );
  reply.out() << _tntChunks[9]; // </td></tr>\n\t\t<tr><td class="message">
#line 41 "error.ecpp"
  reply.sout() << ( errorMessage );
  reply.out() << _tntChunks[10]; // </td></tr>\n\t</table>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
