////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"


#include <timers.h>
#include <tools.h>
#include <setup.h>
#include <epg_events.h>
#include <timerconflict.h>
#include <livefeatures.h>
#include <users.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class timer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        timer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    timer_actions_type timer_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "P\001\000\000\232\001\000\000\007\002\000\000\022\002\000\000\025\002\000\000\032\002\000"
  "\000`\002\000\000c\002\000\000{\002\000\000\177\002\000\000\200\002\000\000\273\002\000\000\373\002\000\000W\003\000"
  "\000&\004\000\000w\004\000\000\310\004\000\000\031\005\000\000j\005\000\000\227\005\000\000\344\005\000\000\021\006"
  "\000\000\303\007\000\000\344\007\000\000\360\007\000\000\371\007\000\000\372\007\000\000\027\010\000\000\222\010\000"
  "\000\225\010\000\000\354\010\000\000\356\010\000\0001\t\000\000p\t\000\000r\t\000\000\225\t\000\000\324\t\000\000\326"
  "\t\000\000\371\t\000\0008\n\000\000:\n\000\000[\n\000\000\232\n\000\000\234\n\000\000\270\n\000\000\325\n\000\000\333"
  "\n\000\000\334\n\000\000\370\n\000\000\001\013\000\000'\013\000\000O\013\000\000p\013\000\000\213\013\000\000\230\013"
  "\000\000\231\013\000\000\276\013\000\000\301\013\000\000\306\013\000\000\372\013\000\000\374\013\000\000\001\014\000"
  "\000,\014\000\000z\014\000\000\224\014\000\000\235\014\000\000\277\014\000\000\365\014\000\000\034\015\000\000_\015"
  "\000\000y\015\000\000\202\015\000\000\262\015\000\000\356\015\000\000\010\016\000\000\021\016\000\000)\016\000\000O"
  "\016\000\000P\016\000\000Q\016\000\000k\016\000\000p\016\000\000\251\016\000\000\256\016\000\000<!DOCTYPE html>\n<htm"
  "l>\n  <script>\n    history.go(-1);\n  </script>\n</html>\n\n<html>\n\t<head>\n\t\t<meta name=\"viewport\" content=\""
  "width=device-width, initial-scale=1\" />\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n    \n\t</head>\n\t<body onload"
  "=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table clas"
  "s=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t\t\t<td colspan=\"12"
  "\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"12\">\n\t\t\t\t\t\t<div class=\"boxhead"
  "er\"><div><div>\n\t\t\t\t\t\t\t\n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\""
  "description\">\n\t\t\t\t\t<td class=\"leftcol\"><img src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16p"
  "x\" /></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n          <td class=\"td-hidden-xs\"><div class=\"w"
  "ithmargin hidden-xs\"></div></td>\n          <td class=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></t"
  "d>\n          <td class=\"td-hidden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n          <td class=\"td-hi"
  "dden-xs\"><div class=\"withmargin hidden-xs\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t"
  "\t\t\t<td class=\"td-hidden-xs\"><div class=\"xs-nomargin hidden-xs\"></div></td>\n\t\t\t\t\t<td><div class=\"withmar"
  "gin\"></div></td>\n          <td class=\"td-hidden-xs\"><img class=\"hidden-xs action-rightcol\" src=\"img/transparen"
  "t.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n          <td class=\"td-hidden-xs\"><img class=\"hidden-xs "
  "action-rightcol\" src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n          <td class=\""
  "rightcol\"><img class=\"action-rightcol\" src=\"img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>"
  "\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n\n\t\t\t\t<td class=\"leftcol \"><img src=\"\" alt=\"\"  /></td>\n          <td class="
  "\"\"><div class=\"withmargin\">\n             <table class=\"noborder\"><tr><td class=\"noborder\"><span class=\"disp"
  "lay-xs nowrap\" >  - </span></td></tr>\n             <tr><td class=\"noborder\"><a href=\"schedule.html\?channel=\"><"
  "/a></td></tr>\n</table>\n          </div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmarg"
  "in nowrap\" title=\"\">  </div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap"
  "\" title=\"\">  </div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\" title="
  "\"\"></div></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs withmargin nowrap\" title=\"\"></div><"
  "/td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a\n\t\t\t\t\t\t\n\t\t\t\t\t\tclass=\"apopup\" title=\"\"\n"
  "\t\t\t\t\t\t></a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class=\" td-hidden-xs\"><div class=\"xs-nomargin\"></div></td"
  ">\n          <td class=\"\"><div class=\"withmargin\">\n\n            \n\t\t\t\t\t    <a href=\"epginfo.html\?epgid="
  "\"> </a>\n\t\t\t\t\t  <a href=\"edit_searchtimer.html\?searchtimerid=\"></a>\n          </div></td>\n          <td cl"
  "ass=\" td-hidden-xs\"><a class=\"hidden-xs action-rightcol\" href=\"timers.html\?timerid=&action=toggle\"><img src=\""
  "\" alt=\"\"  /></a></td>\n          <td class=\" td-hidden-xs\"><div class=\"hidden-xs action-rightcol\"></div></td>"
  "\n\n\t\t\t\t  <td class=\"rightcol \">\n<a class=\"display-xs action-rightcol\" href=\"timers.html\?timerid=&action=t"
  "oggle\"><img src=\"\" alt=\"\"  /></a>\n<div class=\"display-xs action-rightcol\"></div>\n<a class=\"action-rightcol"
  "\" href=\"timers.html\?timerid=&action=delete\"><img src=\"\" alt=\"\"  /></a></td>\n\n\t\t\t\t</tr>\n\t\t\t</table>"
  "\n\t\t</div>\n\t</body>\n</html>\n\n\n<a href=\"edit_timer.html\"></a>\n<span class=\"sep\">|</span>\n<a href=\"timer"
  "conflicts.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    timer_actions(*this, "timer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string timerid = qparam.get< std::string >("timerid");
std::string action = qparam.get< std::string >("action");
  // </%args>

#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 23 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 24 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 27 "timers.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Timers");

	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();
	TimerConflicts timerConflicts;

	timer = 0;
	if ( !timerid.empty() ) {
		std::string tId = SortedTimers::DecodeDomId(timerid);
//		dsyslog("live: DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
		if (action == "delete") {
			if (!cUser::CurrentUserHasRightTo(UR_DELTIMERS))
				throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
//                        dsyslog("live: timers.ecpp timer->Id() %d", timer->Id());
//                        dsyslog("live: timers.ecpp timer->Remote() %s", timer->Remote());
			LiveTimerManager().DelTimer(timer->Id(), timer->Remote());
			timerNotifier.SetTimerModification();
		}
		if (action == "toggle") {
			LiveTimerManager().ToggleTimerActive(timer->Id(), timer->Remote());
			timerNotifier.SetTimerModification();
		}

  reply.out() << _tntChunks[0]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-1);\n  </script>\n</html>\n
#line 63 "timers.ecpp"

	} else {

	std::string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 68 "timers.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 68 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n<html>\n\t<head>\n\t\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 72 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 73 "timers.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 73 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 74 "timers.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 74 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 75 "timers.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 75 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 78 "timers.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 78 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t\t
  // <& menu ...
  { 
#line 79 "timers.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 79 "timers.ecpp"
    _tnt_cq5.add( "active", ("timers"));
#line 79 "timers.ecpp"
    _tnt_cq5.add( "component", ("timers.timer_actions"));
#line 79 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n\t\t<div class="inhalt">\n
#line 81 "timers.ecpp"

		#ifdef DEBUG_LOCK
      dsyslog("live: pages/timers.ecpp LOCK_TIMERS_READ");
    #endif
      const char *lf = "<br/>";
		  LOCK_TIMERS_READ;
      cSortedTimers sortedTimers(Timers);
			if (sortedTimers.Size() == 0) {

  reply.out() << _tntChunks[8]; // \t\t\t\t
#line 90 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << _tntChunks[9]; // \n
#line 91 "timers.ecpp"
			} else {

  reply.out() << _tntChunks[10]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 93 "timers.ecpp"

				// output of the timer list:
                                for (int i = 0; i < sortedTimers.Size(); i++) {
                                        const cTimer *timer = sortedTimers[i];
	                 		EpgInfoPtr epgEvent = 0;
					std::string longDescription;
					std::string searchTimName;
					std::string searchTimId;
					std::string recID;
					std::string recName;

					if (timer->Event())
					{
            epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
            bool truncated = false;
            longDescription  = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer), lf);
            longDescription += "<hr>";
					  longDescription += StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars(), truncated), lf);
					  if (truncated) longDescription += "...";
            AppendHtmlEscapedAndCorrectNonUTF8(searchTimName, SortedTimers::SearchTimerInfo(*timer, "searchtimer"));
            searchTimId = SortedTimers::SearchTimerInfo(*timer, "s-id");
            if (searchTimName.empty() && searchTimId.empty() ) AppendHtmlEscapedAndCorrectNonUTF8(searchTimName, SortedTimers::TvScraperTimerInfo(*timer, recID, recName) );
					}
					std::string currentDay = SortedTimers::GetTimerDays(timer);
          const cTimer *nextTimer =  NULL;
          if (i < (sortedTimers.Size() - 1)) nextTimer = sortedTimers[i + 1];
					bool bottom = false;
					if (i == sortedTimers.Size() - 1) bottom = true;
					else {
						std::string nextDay = SortedTimers::GetTimerDays(nextTimer);
						bottom = (currentDay != nextDay);
					}
					if (previousDay != currentDay) {
						if (!previousDay.empty()) {

  reply.out() << _tntChunks[11]; // \t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="12"/>\n\t\t\t\t\t\t</tr>\n
#line 131 "timers.ecpp"

						}
						previousDay = currentDay;

  reply.out() << _tntChunks[12]; // \t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="12">\n\t\t\t\t\t\t<div class="boxheader"><div><div>\n\t\t\t\t\t\t\t
#line 138 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << _tntChunks[13]; // \n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="leftcol"><img src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 144 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << _tntChunks[14]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 145 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << _tntChunks[15]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 146 "timers.ecpp"
  reply.sout() << ( trVDR("Stop")  );
  reply.out() << _tntChunks[16]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 147 "timers.ecpp"
  reply.sout() << ( tr("Duration") );
  reply.out() << _tntChunks[17]; // </div></td>\n          <td class="td-hidden-xs"><div class="withmargin hidden-xs">
#line 148 "timers.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << _tntChunks[18]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 149 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << _tntChunks[19]; // </div></td>\n\t\t\t\t\t<td class="td-hidden-xs"><div class="xs-nomargin hidden-xs">
#line 150 "timers.ecpp"
  reply.sout() << ( trVDR("Record on") );
  reply.out() << _tntChunks[20]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 151 "timers.ecpp"
  reply.sout() << ( tr("Searchtimer") );
  reply.out() << _tntChunks[21]; // </div></td>\n          <td class="td-hidden-xs"><img class="hidden-xs action-rightcol" src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n          <td class="td-hidden-xs"><img class="hidden-xs action-rightcol" src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n          <td class="rightcol"><img class="action-rightcol" src="img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t</tr>\n
#line 156 "timers.ecpp"

					}
					std::string timerStateImg = "transparent.png";
					std::string timerStateHint;
					if (timer->Recording()) {
						timerStateImg = "arrow_rec.gif";
						timerStateHint = tr("Timer is recording.");
					}
					else if (timer->Flags() & tfActive) {
						if (timerConflicts.HasConflict(timer->Id() )) {
							timerStateImg = "timerconflict.gif";
							timerStateHint = tr("Timer has a conflict.");
						}
						else {
							timerStateImg = "arrow.png";
							timerStateHint = tr("Timer is active.");
						}
					}
          std::string timerFile;
          AppendHtmlEscapedAndCorrectNonUTF8(timerFile, timer->File());

  reply.out() << _tntChunks[22]; // \t\t\t\t<tr>\n\n\t\t\t\t<td class="leftcol 
#line 179 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[23]; // "><img src="
#line 179 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << _tntChunks[24]; // " alt="" 
#line 179 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 179 "timers.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 179 "timers.ecpp"
    _tnt_cq6.add( "text", (timerStateHint));
#line 179 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[25]; //  
#line 179 "timers.ecpp"
 } 
  reply.out() << _tntChunks[26]; // /></td>\n          <td class="
#line 180 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[27]; // "><div class="withmargin">\n             <table class="noborder"><tr><td class="noborder"><span class="display-xs nowrap" > 
#line 181 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[28]; //  - 
#line 181 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[29]; // </span></td></tr>\n             <tr><td class="noborder"><a href="schedule.html\?channel=
#line 182 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << _tntChunks[30]; // ">
#line 182 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << _tntChunks[31]; // </a></td></tr>\n</table>\n          </div></td>\n          <td class="
#line 185 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[32]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" title="
#line 185 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[33]; // ">
#line 185 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << _tntChunks[34]; //   </div></td>\n          <td class="
#line 186 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[35]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" title="
#line 186 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[36]; // ">
#line 186 "timers.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << _tntChunks[37]; //   </div></td>\n          <td class="
#line 187 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[38]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" title="
#line 187 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[39]; // ">
#line 187 "timers.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), timer->StopTime() - timer->StartTime()) );
  reply.out() << _tntChunks[40]; // </div></td>\n          <td class="
#line 188 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[41]; //  td-hidden-xs"><div class="hidden-xs withmargin nowrap" title="
#line 188 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[42]; // ">
#line 188 "timers.ecpp"
  reply.sout() << ( timer->Priority() );
  reply.out() << _tntChunks[43]; // </div></td>\n\t\t\t\t\t<td class="
#line 189 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[44]; // "><div class="withmargin"><a\n
#line 190 "timers.ecpp"
         if(epgEvent) {

  reply.out() << _tntChunks[45]; // \t\t\t\t\t\t
  // <& tooltip.display ...
  { 
#line 191 "timers.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 191 "timers.ecpp"
    _tnt_cq7.add( "domId", (epgEvent->Id()));
#line 191 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[46]; // \n
#line 192 "timers.ecpp"
         }

  reply.out() << _tntChunks[47]; // \t\t\t\t\t\tclass="apopup" title="
#line 193 "timers.ecpp"
  reply.out() << (longDescription);
  reply.out() << _tntChunks[48]; // "\n\t\t\t\t\t\t>
#line 194 "timers.ecpp"
  reply.out() << ( StringReplace(timerFile, "~", "~<wbr>") );
  reply.out() << _tntChunks[49]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="
#line 196 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[50]; //  td-hidden-xs"><div class="xs-nomargin">
#line 196 "timers.ecpp"
  reply.sout() << ( timer->Local()?trVDR(" "):timer->Remote() );
  reply.out() << _tntChunks[51]; // </div></td>\n          <td class="
#line 197 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[52]; // "><div class="withmargin">\n
#line 198 "timers.ecpp"
					if ( !timer->Local() || searchTimId.empty() ) {

  reply.out() << _tntChunks[53]; // \n            
#line 200 "timers.ecpp"
  reply.out() << ( StringReplace(searchTimName, "~", "~<wbr>") );
  reply.out() << _tntChunks[54]; // \n
#line 201 "timers.ecpp"
           if (!recID.empty() ) {

  reply.out() << _tntChunks[55]; // \t\t\t\t\t    <a href="epginfo.html\?epgid=
#line 202 "timers.ecpp"
  reply.sout() << ( recID );
  reply.out() << _tntChunks[56]; // "> 
#line 202 "timers.ecpp"
  reply.out() << ( StringReplace(recName, "~", "~<wbr>") );
  reply.out() << _tntChunks[57]; // </a>\n
#line 203 "timers.ecpp"
           }

#line 204 "timers.ecpp"
					} else {

  reply.out() << _tntChunks[58]; // \t\t\t\t\t  <a href="edit_searchtimer.html\?searchtimerid=
#line 205 "timers.ecpp"
  reply.sout() << ( searchTimId );
  reply.out() << _tntChunks[59]; // ">
#line 205 "timers.ecpp"
  reply.out() << ( StringReplace(searchTimName, "~", "~<wbr>") );
  reply.out() << _tntChunks[60]; // </a>\n
#line 206 "timers.ecpp"
					}

  reply.out() << _tntChunks[61]; //           </div></td>\n          <td class="
#line 208 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[62]; //  td-hidden-xs"><a class="hidden-xs action-rightcol" href="timers.html\?timerid=
#line 208 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[63]; // &action=toggle"><img src="
#line 208 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[64]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 208 "timers.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 208 "timers.ecpp"
    _tnt_cq8.add( "text", (tr("Toggle timer active/inactive")));
#line 208 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[65]; //  /></a></td>\n          <td class="
#line 209 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[66]; //  td-hidden-xs"><div class="hidden-xs action-rightcol">
  // <& pageelems.edit_timer ...
  { 
#line 209 "timers.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 209 "timers.ecpp"
    _tnt_cq9.add( "timerId", (timers.GetTimerId(*timer)));
#line 209 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[67]; // </div></td>\n\n\t\t\t\t  <td class="rightcol 
#line 211 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[68]; // ">\n<a class="display-xs action-rightcol" href="timers.html\?timerid=
#line 212 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[69]; // &action=toggle"><img src="
#line 212 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[70]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 212 "timers.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 212 "timers.ecpp"
    _tnt_cq10.add( "text", (tr("Toggle timer active/inactive")));
#line 212 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[71]; //  /></a>\n<div class="display-xs action-rightcol">
  // <& pageelems.edit_timer ...
  { 
#line 213 "timers.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 213 "timers.ecpp"
    _tnt_cq11.add( "timerId", (timers.GetTimerId(*timer)));
#line 213 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[72]; // </div>\n<a class="action-rightcol" href="timers.html\?timerid=
#line 214 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << _tntChunks[73]; // &action=delete"><img src="
#line 214 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[74]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 214 "timers.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 214 "timers.ecpp"
    _tnt_cq12.add( "text", (tr("Delete timer")));
#line 214 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[75]; //  /></a></td>\n\n\t\t\t\t</tr>\n
#line 217 "timers.ecpp"

				}
			}

  reply.out() << _tntChunks[76]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
#line 225 "timers.ecpp"
 }

  // <%include> page_exit.eh
  reply.out() << _tntChunks[77]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[78]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::timer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::timer_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 23 "timers.ecpp"
  typedef const cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(const cTimer*, timer, ());   // <%request> const cTimer* timer
  _tnt_ignore_unused<timer_type>(timer);
#line 24 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(TimerConflictNotifier, timerNotifier, ());   // <%request> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
#line 20 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[79]; // <a href="edit_timer.html">
#line 229 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << _tntChunks[80]; // </a>\n
#line 230 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[81]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 232 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << _tntChunks[82]; // </a>\n
#line 233 "timers.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
